"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
function isSource(input) {
    return input instanceof graphql_1.Source;
}
function isDocumentNode(input) {
    return input.kind === 'Document';
}
function extractExtensions(input) {
    let doc;
    if (isDocumentNode(input)) {
        doc = input;
    }
    else if (isSource(input)) {
        doc = graphql_1.parse(input);
    }
    else if (typeof input === 'string') {
        doc = graphql_1.parse(input);
    }
    else {
        throw new Error('Only DocumentNode, Source and string are accepted');
    }
    const exclude = [
        graphql_1.Kind.SCALAR_TYPE_DEFINITION,
        graphql_1.Kind.OBJECT_TYPE_DEFINITION,
        graphql_1.Kind.INTERFACE_TYPE_DEFINITION,
        graphql_1.Kind.UNION_TYPE_DEFINITION,
        graphql_1.Kind.ENUM_TYPE_DEFINITION,
        graphql_1.Kind.DIRECTIVE_DEFINITION,
    ];
    return graphql_1.visit(doc, exclude.reduce((visitor, kind) => {
        visitor[kind] = () => null;
        return visitor;
    }, {}));
}
exports.extractExtensions = extractExtensions;
//# sourceMappingURL=extract-extensions.js.map